security:
    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email
        jwt:
            lexik_jwt: 
                class: App\Entity\User
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false

        refresh:
            pattern:  ^/api/token/refresh
            provider: app_user_provider
            stateless: true

        login:
            pattern: ^/sec/login|^/sec/resetpwd
            stateless: true
            provider: app_user_provider
            json_login:
                check_path: sec_login
            logout:
                path: sec_logout
            custom_authenticator: App\Security\LoginAuthenticator
        2facheck:
            pattern: ^/sec/2fa_check|^/sec/resendcode
            stateless: true
            custom_authenticator: App\Security\CodeAuthenticator

        # login:
        #     pattern: ^/api/login$
        #     stateless: true
        #     provider: app_user_provider
        #     json_login:
        #         check_path: api_login
        #         success_handler: lexik_jwt_authentication.handler.authentication_success
        #         failure_handler: lexik_jwt_authentication.handler.authentication_failure
            # refresh_jwt:
            #     check_path: api_token_refresh


        public:
            pattern: ^/api/public|^/api/docs
            security: false
        
        api:
            pattern:   ^/api|^/import
            stateless: true
            provider: jwt
            jwt: ~
            

        main:
            security: false


            # activate different ways to authenticate
            # https://symfony.com/doc/current/security.html#the-firewall

            # https://symfony.com/doc/current/security/impersonating_user.html
            # switch_user: true

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/api/login, roles: PUBLIC_ACCESS }
        - { path: ^/api/token/refresh, roles: PUBLIC_ACCESS }
        - { path: ^/api,       roles: IS_AUTHENTICATED_FULLY }
        - { path: ^/sec, role: PUBLIC_ACCESS }
        - { path: ^/logout, role: PUBLIC_ACCESS }
        # je ne sais pas si c'est utile ... a voir si on retrouve bien le role ROLE_2FA_IN_PROGRESS dans le user
        - { path: ^/sec/2fa_check, role: ROLE_2FA_IN_PROGRESS }

    role_hierarchy:
        ROLE_ADMIN: ROLE_USER


when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
